#include <stdlib.h>
#include "AdjMatrix.h"


/* -----------------
 * Private Functions ======================================================
 * ----------------- 
 */

/* creates an edge betwen to nodes */
void _adjmat_link(AdjMatrix *adjmat, int node1, int node2) {

  /* no self linking */
  if (node1 == node2)
    return;

  /* matrix is lower triangular */
  (node1 > node2) ?
    (adjmat->matrix[node1][node2] = 1) :
    (adjmat->matrix[node2][node1] = 1);
}

void _adjmat_init(AdjMatrix *adjmat) {
  int x, y;
  for ( y = 0; y < adjmat->size ; y++)
    for ( x = 0; x <= y ; x++)
      adjmat->matrix[y][x] = 0;
}


/* ----------------
 * Public Functions =======================================================
 * ---------------- 
 */

/* creates a triangular matrix for use as
 * an undirected graph 
 */
AdjMatrix newAdjMatrix(int size) {
  int       i;
  AdjMatrix adjmat;

  /* initialize actual matrix */
  adjmat.matrix = malloc(size * sizeof(short*));
  for (i = 1 ; i <= size ; i++) {
    adjmat.matrix[i-1] = calloc(i, sizeof(short));
  }

  adjmat.size = size;

  adjmat.link = _adjmat_link;
  adjmat.init = _adjmat_init;
  
  return adjmat;
}
  
