#include <stdlib.h>
#include "Graph.h"

/* -----------------
 * Private Functions ======================================================
 * ----------------- 
 */

void _G_link(Graph *G, int node1, int node2) {
  if (G->hasUnionFind)
    G->unionfind.link(&G->unionfind, node1, node2);
  if (G->hasList)
    G->adjlist.link(&G->adjlist, node1, node2);
  if (G->hasMatrix)
    G->adjmat.link(&G->adjmat, node1, node2);
}


/* ----------------
 * Public Functions =======================================================
 * ---------------- 
 */

Graph newGraph(Opts* opts) {
    Graph G;
    
    G.size      = opts->size;
    G.link      = _G_link;

    G.hasMatrix    = 0;
    G.hasList      = 0;
    G.hasUnionFind = 0;
      
    if (opts->useUnionFind) {
      G.unionfind = newUnionFind(G.size);
      G.hasUnionFind = 1;
    }
    if (opts->useMatrix) {
      G.adjmat    = newAdjMatrix(G.size);
      G.hasMatrix = 1;
    }
    /* make this our default data type */
    if (opts->useList) {
      G.adjlist   = newAdjList(G.size);
      G.hasList   = 1;
    }
   
    return G;
}

