#ifndef   _GRAPH_H
#define   _GRAPH_H        1


#include  "AdjList.h"
#include  "AdjMatrix.h"
#include  "UnionFind.h"


typedef struct graph {
  int       size;       /* number of nodes */
  AdjList   adjlist;    /* adjacency list */
  AdjMatrix adjmat;     /* adjacency matrix */
  UnionFind unionfind;  /* union find node array */
  void      (*link)(struct graph *,int,int);

  int       hasMatrix;
  int       hasList;
  int       hasUnionFind;
  
} Graph;


typedef struct opts {

  char*   type;
  double  prob;
  int     size;
  int     links;
  int     samples;

  int     useMatrix;
  int     useList;
  int     useUnionFind;
  
  int     measCluster;
  int     measComponent;
  int     measDegree;
  int     measCompDeg;
  int     measLength;

  int     printDot;
  int     printGraphrep;

  Graph*  G;

} Opts;


Graph newGraph(Opts*);

Opts* newOpts(int argv, char **argc);
void  printOptsUsage(char *name);


#endif
